package test.rewolucja.resources.physical.factory;

import schedframe.resources.units.Cost;
import schedframe.resources.units.Memory;
import test.rewolucja.resources.Category;
import test.rewolucja.resources.description.ExecResourceDescription;
import test.rewolucja.resources.physical.base.ComputingResource;
import test.rewolucja.resources.physical.implementation.ComputingNode;

public class ComputingNodeFactory {
	/*public static ComputingResource createComputingNodeOld(ExecResourceDescription resDesc){
		ResourceCharacteristics resourceCharacteristic = new ResourceCharacteristics();
		String resName = resDesc.getResourceId();
		Category cat = resDesc.getCategory();
		if(cat.getName().equals("A")){
			resourceCharacteristic.addResourceUnit(new Memory(resName, 12288, 0));
			resourceCharacteristic.addResourceUnit(new Cost(resName, 100));
			return new ComputingNode(resName, resourceCharacteristic, resDesc.getCategory(), resDesc.getPowerProfile());
		} else if (cat.getName().equals("B")){
			resourceCharacteristic.addResourceUnit(new Memory(resName, 12288, 0));
			resourceCharacteristic.addResourceUnit(new Cost(resName, 100));
			return new ComputingNode(resName, resourceCharacteristic, resDesc.getCategory(), resDesc.getPowerProfile());
		} else if (cat.getName().equals("C")){
			resourceCharacteristic.addResourceUnit(new Memory(resName, 12288, 0));
			resourceCharacteristic.addResourceUnit(new Cost(resName, 100));
			return new ComputingNode(resName, resourceCharacteristic, resDesc.getCategory(), resDesc.getPowerProfile());
		} else {
			resourceCharacteristic.addResourceUnit(new Memory(resName, 12288, 0));
			resourceCharacteristic.addResourceUnit(new Cost(resName, 100));
			return new ComputingNode(resName, resourceCharacteristic, new Category("unknown"), resDesc.getPowerProfile());
		}

	} */
	
	public static ComputingResource createComputingNode(ExecResourceDescription resDesc){
		String resName = resDesc.getResourceId();
		Category cat = resDesc.getCategory();
		
		if(cat.getName().equals("A"))
		{
			resDesc.addResourceUnit(new Memory(resName, 8704, 0));
			resDesc.addResourceUnit(new Cost(resName, 100));
			return new ComputingNode(resDesc);
		}
		else if (cat.getName().equals("B"))
		{
			resDesc.addResourceUnit(new Memory(resName, 6144, 0));
			resDesc.addResourceUnit(new Cost(resName, 100));
			return new ComputingNode(resDesc);
		}
		else if (cat.getName().equals("C"))
		{
			resDesc.addResourceUnit(new Memory(resName, 0, 0));
			resDesc.addResourceUnit(new Cost(resName, 100));
			return new ComputingNode(resDesc);
		}
		else
		{
			resDesc.addResourceUnit(new Memory(resName, 0, 0));
			resDesc.addResourceUnit(new Cost(resName, 100));
			return new ComputingNode(resDesc);
		}

	} 
}
